git-fetch.shon commit git-svn: allow 'init' to act as multi-init (dadc6d2)
   1#!/bin/sh
   2#
   3
   4USAGE='<fetch-options> <repository> <refspec>...'
   5SUBDIRECTORY_OK=Yes
   6. git-sh-setup
   7set_reflog_action "fetch $*"
   8cd_to_toplevel ;# probably unnecessary...
   9
  10. git-parse-remote
  11_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  12_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
  13
  14LF='
  15'
  16IFS="$LF"
  17
  18no_tags=
  19tags=
  20append=
  21force=
  22verbose=
  23update_head_ok=
  24exec=
  25keep=
  26shallow_depth=
  27while case "$#" in 0) break ;; esac
  28do
  29        case "$1" in
  30        -a|--a|--ap|--app|--appe|--appen|--append)
  31                append=t
  32                ;;
  33        --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
  34        --upload-pa|--upload-pac|--upload-pack)
  35                shift
  36                exec="--upload-pack=$1"
  37                ;;
  38        --upl=*|--uplo=*|--uploa=*|--upload=*|\
  39        --upload-=*|--upload-p=*|--upload-pa=*|--upload-pac=*|--upload-pack=*)
  40                exec=--upload-pack=$(expr "z$1" : 'z-[^=]*=\(.*\)')
  41                shift
  42                ;;
  43        -f|--f|--fo|--for|--forc|--force)
  44                force=t
  45                ;;
  46        -t|--t|--ta|--tag|--tags)
  47                tags=t
  48                ;;
  49        -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
  50                no_tags=t
  51                ;;
  52        -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
  53        --update-he|--update-hea|--update-head|--update-head-|\
  54        --update-head-o|--update-head-ok)
  55                update_head_ok=t
  56                ;;
  57        -v|--verbose)
  58                verbose=Yes
  59                ;;
  60        -k|--k|--ke|--kee|--keep)
  61                keep='-k -k'
  62                ;;
  63        --depth=*)
  64                shallow_depth="--depth=`expr "z$1" : 'z-[^=]*=\(.*\)'`"
  65                ;;
  66        --depth)
  67                shift
  68                shallow_depth="--depth=$1"
  69                ;;
  70        -*)
  71                usage
  72                ;;
  73        *)
  74                break
  75                ;;
  76        esac
  77        shift
  78done
  79
  80case "$#" in
  810)
  82        origin=$(get_default_remote)
  83        test -n "$(get_remote_url ${origin})" ||
  84                die "Where do you want to fetch from today?"
  85        set x $origin ; shift ;;
  86esac
  87
  88if test -z "$exec"
  89then
  90        # No command line override and we have configuration for the remote.
  91        exec="--upload-pack=$(get_uploadpack $1)"
  92fi
  93
  94remote_nick="$1"
  95remote=$(get_remote_url "$@")
  96refs=
  97rref=
  98rsync_slurped_objects=
  99
 100if test "" = "$append"
 101then
 102        : >"$GIT_DIR/FETCH_HEAD"
 103fi
 104
 105# Global that is reused later
 106ls_remote_result=$(git ls-remote $exec "$remote") ||
 107        die "Cannot get the repository state from $remote"
 108
 109append_fetch_head () {
 110    head_="$1"
 111    remote_="$2"
 112    remote_name_="$3"
 113    remote_nick_="$4"
 114    local_name_="$5"
 115    case "$6" in
 116    t) not_for_merge_='not-for-merge' ;;
 117    '') not_for_merge_= ;;
 118    esac
 119
 120    # remote-nick is the URL given on the command line (or a shorthand)
 121    # remote-name is the $GIT_DIR relative refs/ path we computed
 122    # for this refspec.
 123
 124    # the $note_ variable will be fed to git-fmt-merge-msg for further
 125    # processing.
 126    case "$remote_name_" in
 127    HEAD)
 128        note_= ;;
 129    refs/heads/*)
 130        note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
 131        note_="branch '$note_' of " ;;
 132    refs/tags/*)
 133        note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
 134        note_="tag '$note_' of " ;;
 135    refs/remotes/*)
 136        note_="$(expr "$remote_name_" : 'refs/remotes/\(.*\)')"
 137        note_="remote branch '$note_' of " ;;
 138    *)
 139        note_="$remote_name of " ;;
 140    esac
 141    remote_1_=$(expr "z$remote_" : 'z\(.*\)\.git/*$') &&
 142        remote_="$remote_1_"
 143    note_="$note_$remote_"
 144
 145    # 2.6.11-tree tag would not be happy to be fed to resolve.
 146    if git-cat-file commit "$head_" >/dev/null 2>&1
 147    then
 148        headc_=$(git-rev-parse --verify "$head_^0") || exit
 149        echo "$headc_   $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
 150    else
 151        echo "$head_    not-for-merge   $note_" >>"$GIT_DIR/FETCH_HEAD"
 152    fi
 153
 154    update_local_ref "$local_name_" "$head_" "$note_"
 155}
 156
 157update_local_ref () {
 158    # If we are storing the head locally make sure that it is
 159    # a fast forward (aka "reverse push").
 160
 161    label_=$(git-cat-file -t $2)
 162    newshort_=$(git-rev-parse --short $2)
 163    if test -z "$1" ; then
 164        [ "$verbose" ] && echo >&2 "* fetched $3"
 165        [ "$verbose" ] && echo >&2 "  $label_: $newshort_"
 166        return 0
 167    fi
 168    oldshort_=$(git show-ref --hash --abbrev "$1" 2>/dev/null)
 169
 170    case "$1" in
 171    refs/tags/*)
 172        # Tags need not be pointing at commits so there
 173        # is no way to guarantee "fast-forward" anyway.
 174        if test -n "$oldshort_"
 175        then
 176                if now_=$(git show-ref --hash "$1") && test "$now_" = "$2"
 177                then
 178                        [ "$verbose" ] && echo >&2 "* $1: same as $3"
 179                        [ "$verbose" ] && echo >&2 "  $label_: $newshort_" ||:
 180                else
 181                        echo >&2 "* $1: updating with $3"
 182                        echo >&2 "  $label_: $newshort_"
 183                        git-update-ref -m "$GIT_REFLOG_ACTION: updating tag" "$1" "$2"
 184                fi
 185        else
 186                echo >&2 "* $1: storing $3"
 187                echo >&2 "  $label_: $newshort_"
 188                git-update-ref -m "$GIT_REFLOG_ACTION: storing tag" "$1" "$2"
 189        fi
 190        ;;
 191
 192    refs/heads/* | refs/remotes/*)
 193        # $1 is the ref being updated.
 194        # $2 is the new value for the ref.
 195        local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
 196        if test "$local"
 197        then
 198            # Require fast-forward.
 199            mb=$(git-merge-base "$local" "$2") &&
 200            case "$2,$mb" in
 201            $local,*)
 202                if test -n "$verbose"
 203                then
 204                        echo >&2 "* $1: same as $3"
 205                        echo >&2 "  $label_: $newshort_"
 206                fi
 207                ;;
 208            *,$local)
 209                echo >&2 "* $1: fast forward to $3"
 210                echo >&2 "  old..new: $oldshort_..$newshort_"
 211                git-update-ref -m "$GIT_REFLOG_ACTION: fast-forward" "$1" "$2" "$local"
 212                ;;
 213            *)
 214                false
 215                ;;
 216            esac || {
 217                case ",$force,$single_force," in
 218                *,t,*)
 219                        echo >&2 "* $1: forcing update to non-fast forward $3"
 220                        echo >&2 "  old...new: $oldshort_...$newshort_"
 221                        git-update-ref -m "$GIT_REFLOG_ACTION: forced-update" "$1" "$2" "$local"
 222                        ;;
 223                *)
 224                        echo >&2 "* $1: not updating to non-fast forward $3"
 225                        echo >&2 "  old...new: $oldshort_...$newshort_"
 226                        exit 1
 227                        ;;
 228                esac
 229            }
 230        else
 231            echo >&2 "* $1: storing $3"
 232            echo >&2 "  $label_: $newshort_"
 233            git-update-ref -m "$GIT_REFLOG_ACTION: storing head" "$1" "$2"
 234        fi
 235        ;;
 236    esac
 237}
 238
 239# updating the current HEAD with git-fetch in a bare
 240# repository is always fine.
 241if test -z "$update_head_ok" && test $(is_bare_repository) = false
 242then
 243        orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 244fi
 245
 246# Allow --notags from remote.$1.tagopt
 247case "$tags$no_tags" in
 248'')
 249        case "$(git-config --get "remote.$1.tagopt")" in
 250        --no-tags)
 251                no_tags=t ;;
 252        esac
 253esac
 254
 255# If --tags (and later --heads or --all) is specified, then we are
 256# not talking about defaults stored in Pull: line of remotes or
 257# branches file, and just fetch those and refspecs explicitly given.
 258# Otherwise we do what we always did.
 259
 260reflist=$(get_remote_refs_for_fetch "$@")
 261if test "$tags"
 262then
 263        taglist=`IFS='  ' &&
 264                  echo "$ls_remote_result" |
 265                  git-show-ref --exclude-existing=refs/tags/ |
 266                  while read sha1 name
 267                  do
 268                        echo ".${name}:${name}"
 269                  done` || exit
 270        if test "$#" -gt 1
 271        then
 272                # remote URL plus explicit refspecs; we need to merge them.
 273                reflist="$reflist$LF$taglist"
 274        else
 275                # No explicit refspecs; fetch tags only.
 276                reflist=$taglist
 277        fi
 278fi
 279
 280fetch_main () {
 281  reflist="$1"
 282  refs=
 283  rref=
 284
 285  for ref in $reflist
 286  do
 287      refs="$refs$LF$ref"
 288
 289      # These are relative path from $GIT_DIR, typically starting at refs/
 290      # but may be HEAD
 291      if expr "z$ref" : 'z\.' >/dev/null
 292      then
 293          not_for_merge=t
 294          ref=$(expr "z$ref" : 'z\.\(.*\)')
 295      else
 296          not_for_merge=
 297      fi
 298      if expr "z$ref" : 'z+' >/dev/null
 299      then
 300          single_force=t
 301          ref=$(expr "z$ref" : 'z+\(.*\)')
 302      else
 303          single_force=
 304      fi
 305      remote_name=$(expr "z$ref" : 'z\([^:]*\):')
 306      local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
 307
 308      rref="$rref$LF$remote_name"
 309
 310      # There are transports that can fetch only one head at a time...
 311      case "$remote" in
 312      http://* | https://* | ftp://*)
 313          test -n "$shallow_depth" &&
 314                die "shallow clone with http not supported"
 315          proto=`expr "$remote" : '\([^:]*\):'`
 316          if [ -n "$GIT_SSL_NO_VERIFY" ]; then
 317              curl_extra_args="-k"
 318          fi
 319          if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
 320                "`git-config --bool http.noEPSV`" = true ]; then
 321              noepsv_opt="--disable-epsv"
 322          fi
 323
 324          # Find $remote_name from ls-remote output.
 325          head=$(
 326                IFS='   '
 327                echo "$ls_remote_result" |
 328                while read sha1 name
 329                do
 330                        test "z$name" = "z$remote_name" || continue
 331                        echo "$sha1"
 332                        break
 333                done
 334          )
 335          expr "z$head" : "z$_x40\$" >/dev/null ||
 336                die "No such ref $remote_name at $remote"
 337          echo >&2 "Fetching $remote_name from $remote using $proto"
 338          git-http-fetch -v -a "$head" "$remote/" || exit
 339          ;;
 340      rsync://*)
 341          test -n "$shallow_depth" &&
 342                die "shallow clone with rsync not supported"
 343          TMP_HEAD="$GIT_DIR/TMP_HEAD"
 344          rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
 345          head=$(git-rev-parse --verify TMP_HEAD)
 346          rm -f "$TMP_HEAD"
 347          test "$rsync_slurped_objects" || {
 348              rsync -av --ignore-existing --exclude info \
 349                  "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
 350
 351              # Look at objects/info/alternates for rsync -- http will
 352              # support it natively and git native ones will do it on
 353              # the remote end.  Not having that file is not a crime.
 354              rsync -q "$remote/objects/info/alternates" \
 355                  "$GIT_DIR/TMP_ALT" 2>/dev/null ||
 356                  rm -f "$GIT_DIR/TMP_ALT"
 357              if test -f "$GIT_DIR/TMP_ALT"
 358              then
 359                  resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
 360                  while read alt
 361                  do
 362                      case "$alt" in 'bad alternate: '*) die "$alt";; esac
 363                      echo >&2 "Getting alternate: $alt"
 364                      rsync -av --ignore-existing --exclude info \
 365                      "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
 366                  done
 367                  rm -f "$GIT_DIR/TMP_ALT"
 368              fi
 369              rsync_slurped_objects=t
 370          }
 371          ;;
 372      *)
 373          # We will do git native transport with just one call later.
 374          continue ;;
 375      esac
 376
 377      append_fetch_head "$head" "$remote" \
 378          "$remote_name" "$remote_nick" "$local_name" "$not_for_merge" || exit
 379
 380  done
 381
 382  case "$remote" in
 383  http://* | https://* | ftp://* | rsync://* )
 384      ;; # we are already done.
 385  *)
 386    ( : subshell because we muck with IFS
 387      IFS="     $LF"
 388      (
 389          git-fetch-pack --thin $exec $keep $shallow_depth "$remote" $rref ||
 390          echo failed "$remote"
 391      ) |
 392      (
 393        trap '
 394                if test -n "$keepfile" && test -f "$keepfile"
 395                then
 396                        rm -f "$keepfile"
 397                fi
 398        ' 0
 399
 400        keepfile=
 401        while read sha1 remote_name
 402        do
 403          case "$sha1" in
 404          failed)
 405                  echo >&2 "Fetch failure: $remote"
 406                  exit 1 ;;
 407          # special line coming from index-pack with the pack name
 408          pack)
 409                  continue ;;
 410          keep)
 411                  keepfile="$GIT_OBJECT_DIRECTORY/pack/pack-$remote_name.keep"
 412                  continue ;;
 413          esac
 414          found=
 415          single_force=
 416          for ref in $refs
 417          do
 418              case "$ref" in
 419              +$remote_name:*)
 420                  single_force=t
 421                  not_for_merge=
 422                  found="$ref"
 423                  break ;;
 424              .+$remote_name:*)
 425                  single_force=t
 426                  not_for_merge=t
 427                  found="$ref"
 428                  break ;;
 429              .$remote_name:*)
 430                  not_for_merge=t
 431                  found="$ref"
 432                  break ;;
 433              $remote_name:*)
 434                  not_for_merge=
 435                  found="$ref"
 436                  break ;;
 437              esac
 438          done
 439          local_name=$(expr "z$found" : 'z[^:]*:\(.*\)')
 440          append_fetch_head "$sha1" "$remote" \
 441                  "$remote_name" "$remote_nick" "$local_name" \
 442                  "$not_for_merge" || exit
 443        done
 444      )
 445    ) || exit ;;
 446  esac
 447
 448}
 449
 450fetch_main "$reflist" || exit
 451
 452# automated tag following
 453case "$no_tags$tags" in
 454'')
 455        case "$reflist" in
 456        *:refs/*)
 457                # effective only when we are following remote branch
 458                # using local tracking branch.
 459                taglist=$(IFS=' ' &&
 460                echo "$ls_remote_result" |
 461                git-show-ref --exclude-existing=refs/tags/ |
 462                while read sha1 name
 463                do
 464                        git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
 465                        echo >&2 "Auto-following $name"
 466                        echo ".${name}:${name}"
 467                done)
 468        esac
 469        case "$taglist" in
 470        '') ;;
 471        ?*)
 472                # do not deepen a shallow tree when following tags
 473                shallow_depth=
 474                fetch_main "$taglist" || exit ;;
 475        esac
 476esac
 477
 478# If the original head was empty (i.e. no "master" yet), or
 479# if we were told not to worry, we do not have to check.
 480case "$orig_head" in
 481'')
 482        ;;
 483?*)
 484        curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 485        if test "$curr_head" != "$orig_head"
 486        then
 487            git-update-ref \
 488                        -m "$GIT_REFLOG_ACTION: Undoing incorrectly fetched HEAD." \
 489                        HEAD "$orig_head"
 490                die "Cannot fetch into the current branch."
 491        fi
 492        ;;
 493esac